

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>4.11. Query expansion &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script src="../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="5. Server" href="../server.html" />
    <link rel="prev" title="4.10. Let’s create micro-blog" href="micro_blog.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../ja/html/tutorial/query_expansion.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../server.html" title="5. Server"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="micro_blog.html" title="4.10. Let’s create micro-blog"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../tutorial.html" accesskey="U"><span class="section-number">4. </span>Tutorial</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">4.11. </span>Query expansion</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="query-expansion">
<h1><span class="section-number">4.11. </span>Query expansion<a class="headerlink" href="#query-expansion" title="Permalink to this headline">¶</a></h1>
<p>Groonga accepts <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> parameter for <a class="reference internal" href="../reference/commands/select.html"><span class="doc">select</span></a> command.
It enables you to extend your query string.</p>
<p>For example, if user searches “theatre” instead of “theater”,
query expansion enables to return search results of “theatre OR theater”.
This kind of way reduces search leakages. This is what really user wants.</p>
<div class="section" id="preparation">
<h2><span class="section-number">4.11.1. </span>Preparation<a class="headerlink" href="#preparation" title="Permalink to this headline">¶</a></h2>
<p>To use query expansion, you need to create table which stores documents, synonym table which stores query string and replacement string.
In synonym table, primary key represents original string, the column of ShortText represents modified string.</p>
<p>Let’s create document table and synonym table.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Doc TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Doc body COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Term TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Term Doc_body COLUMN_INDEX|WITH_POSITION Doc body
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Synonym TABLE_PAT_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Synonym body COLUMN_VECTOR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Doc
[
{&quot;_key&quot;: &quot;001&quot;, &quot;body&quot;: &quot;Play all night in this theater.&quot;},
{&quot;_key&quot;: &quot;002&quot;, &quot;body&quot;: &quot;theatre is British spelling.&quot;},
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
load --table Synonym
[
{&quot;_key&quot;: &quot;theater&quot;, &quot;body&quot;: [&quot;theater&quot;, &quot;theatre&quot;]},
{&quot;_key&quot;: &quot;theatre&quot;, &quot;body&quot;: [&quot;theater&quot;, &quot;theatre&quot;]},
]
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p>In this case, it doesn’t occur search leakage because it creates synonym table which accepts “theatre” and “theater” as query string.</p>
</div>
<div class="section" id="search">
<h2><span class="section-number">4.11.2. </span>Search<a class="headerlink" href="#search" title="Permalink to this headline">¶</a></h2>
<p>Then, let’s use prepared synonym table.
First, use select command without <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> parameter.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Doc --match_columns body --query &quot;theater&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ]
#     ]
#   ]
# ]
select Doc --match_columns body --query &quot;theatre&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>Above query returns the record which completely equal to query string.</p>
<p>Then, use <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> parameter against <code class="docutils literal notranslate"><span class="pre">body</span></code> column of <code class="docutils literal notranslate"><span class="pre">Synonym</span></code> table.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Doc --match_columns body --query &quot;theater&quot; --query_expander Synonym.body
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
select Doc --match_columns body --query &quot;theatre&quot; --query_expander Synonym.body
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         2
#       ],
#       [
#         [
#           &quot;_id&quot;,
#           &quot;UInt32&quot;
#         ],
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;body&quot;,
#           &quot;ShortText&quot;
#         ]
#       ],
#       [
#         1,
#         &quot;001&quot;,
#         &quot;Play all night in this theater.&quot;
#       ],
#       [
#         2,
#         &quot;002&quot;,
#         &quot;theatre is British spelling.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>In which cases, query string is replaced to “(theater OR theatre)”, thus synonym is considered for full text search.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">4.11. Query expansion</a><ul>
<li><a class="reference internal" href="#preparation">4.11.1. Preparation</a></li>
<li><a class="reference internal" href="#search">4.11.2. Search</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="micro_blog.html"
                        title="previous chapter"><span class="section-number">4.10. </span>Let’s create micro-blog</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="../server.html"
                        title="next chapter"><span class="section-number">5. </span>Server</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../server.html" title="5. Server"
             >next</a> |</li>
        <li class="right" >
          <a href="micro_blog.html" title="4.10. Let’s create micro-blog"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../tutorial.html" ><span class="section-number">4. </span>Tutorial</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">4.11. </span>Query expansion</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>